summaryrefslogtreecommitdiffstats
path: root/k3b-plugins
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2006-12-29 19:18:22 +0000
committer Eric Hameleers <alien@slackware.com>2006-12-29 19:18:22 +0000
commit57599a2d9992c737c6792f75fa837617da507d60 (patch)
tree9427c352b2bb14e6bed900f08e577d7afecae4c0 /k3b-plugins
parent25482f62909cf04c0ad6e829484941dbde958c79 (diff)
downloadasb-57599a2d9992c737c6792f75fa837617da507d60.tar.gz
asb-57599a2d9992c737c6792f75fa837617da507d60.tar.xz
Initial revision
Diffstat (limited to 'k3b-plugins')
-rwxr-xr-xk3b-plugins/build/k3b-plugins.SlackBuild232
-rw-r--r--k3b-plugins/build/slack-required3
2 files changed, 235 insertions, 0 deletions
diff --git a/k3b-plugins/build/k3b-plugins.SlackBuild b/k3b-plugins/build/k3b-plugins.SlackBuild
new file mode 100755
index 00000000..e223c03e
--- /dev/null
+++ b/k3b-plugins/build/k3b-plugins.SlackBuild
@@ -0,0 +1,232 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: k3b-plugins
+# Descr: support for additional sound format conversion
+# URL: http://k3b.org
+# Needs: k3b, libsndfile, libmpcdec
+# Changelog:
+# 0.12.17-1: 29/Dec/2006 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh k3b-plugins.SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# --- INIT ---
+# Set initial variables:
+
+PRGNAM=k3b-plugins
+SRCNAM=k3b
+VERSION=${VERSION:-0.12.17}
+ARCH=${ARCH:-i486}
+BUILD=${BUILD:-1}
+
+DOCS="AUTHORS COPYING k3b.lsm"
+
+# Where do we look for sources?
+CWD=`pwd`
+SRCDIR=`dirname $0`
+[ "${SRCDIR:0:1}" == "." ] && SRCDIR=${CWD}/${SRCDIR}
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Input URL: http://dl.sourceforge.net/k3b/k3b-0.12.17.tar.bz2
+SOURCE="$SRCDIR/${SRCNAM}-${VERSION}.tar.bz2"
+SRCURL="http://dl.sourceforge.net/${SRCNAM}/${SRCNAM}-${VERSION}.tar.bz2"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ `gcc -dumpversion | tr -d '.' |cut -c 1-2` -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
+case "$ARCH" in
+ i386) SLKCFLAGS="-O2 -march=i386 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+if [ ! -d $TMP/tmp-$PRGNAM ]; then
+ mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+elif [ "$P1" != "--oldbuild" ]; then
+ # If the "--oldbuild" parameter is present, we keep
+ # the old build files and continue;
+ # By default we remove the remnants of previous build and continue:
+ rm -rf $TMP/tmp-$PRGNAM/*
+fi
+
+if [ ! -d $PKG ]; then
+ mkdir -p $PKG # place for the package to be built
+else
+ rm -rf $PKG/* # We always erase old package's contents:
+fi
+
+if [ ! -d $OUTPUT ]; then
+ mkdir -p $OUTPUT # place for the package to be saved
+fi
+
+
+# --- SOURCE FILE AVAILABILITY ---
+
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/`basename $SOURCE`"
+ echo "Source '`basename ${SOURCE}`' not available yet..."
+ echo "Will download file to `dirname $SOURCE`"
+ wget -nv -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 ]; then
+ echo "Downloading '`basename ${SOURCE}`' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '`basename ${SOURCE}`' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+
+echo "Extracting the source archive(s) for $PRGNAM..."
+if `file ${SOURCE} | grep -q ": bzip2"`; then
+ tar -xjvf ${SOURCE}
+else
+ tar -xzvf ${SOURCE}
+fi
+cd ${SRCNAM}-${VERSION}
+
+chown -R root.root *
+find . -perm 777 -exec chmod 755 {} \;
+find . -perm 666 -exec chmod 644 {} \;
+
+
+# --- BUILDING ---
+
+echo Building ...
+
+LDFLAGS="$SLKLDFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure --prefix=`kde-config --prefix` \
+ --with-musepack \
+ --with-sndfile \
+ --program-prefix="" \
+ --program-suffix="" \
+ $ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+make -C libk3bdevice 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make -C libk3b 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+make -C plugins/decoder/libsndfile 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+make -C plugins/decoder/musepack 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+
+#
+# Install all the needed stuff to the package dir
+#
+# Use installwatch if available, to produce a logfile of the installation
+# process that is more easily readable:
+if `which installwatch > /dev/null 2>&1`; then
+ installwatch -o $OUTPUT/install-${PRGNAM}.log \
+ make -C plugins/decoder/libsndfile DESTDIR=$PKG install
+ installwatch -o $OUTPUT/install2-${PRGNAM}.log \
+ make -C plugins/decoder/musepack DESTDIR=$PKG install
+else
+ make -C plugins/decoder/libsndfile DESTDIR=$PKG install \
+ 2>&1 |tee $OUTPUT/install-${PRGNAM}.log
+ make -C plugins/decoder/musepack DESTDIR=$PKG install \
+ 2>&1 |tee -a $OUTPUT/install-${PRGNAM}.log
+fi
+
+
+# --- DOCUMENTATION ---
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+chmod -R a-w $PKG/usr/doc/$PRGNAM-$VERSION/*
+
+# Strip binaries
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+
+# --- OWNERSHIP, RIGHTS ---
+
+chmod -R o-w $PKG
+
+
+# --- PACKAGE DESCRIPTION ---
+
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+fi
+
+
+# --- BUILDING ---
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz \
+ 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+(cd $OUTPUT && md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.tgz.md5)
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}.txt
+
+
+# --- CLEANUP ---
+
+# Clean up the extra stuff:
+if [ "$P1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi
diff --git a/k3b-plugins/build/slack-required b/k3b-plugins/build/slack-required
new file mode 100644
index 00000000..fc4f1234
--- /dev/null
+++ b/k3b-plugins/build/slack-required
@@ -0,0 +1,3 @@
+k3b
+libsndfile
+libmpcdec